#!------------------------------------------------------------------------------
#TEMPLATE(ROA_Extensions,' ')
#!------------------------------------------------------------------------------
#!  Copyright ROA Hard&Soft ltd. 2000, Oleg A. Rudenko
#!------------------------------------------------------------------------------
#!------------------------------------------------------------------------------
#EXTENSION(SetReportControlFont,'    '),PROCEDURE
#!------------------------------------------------------------------------------
#RESTRICT,WHERE(%Report)
#ENDRESTRICT
#!
#BOXED('')
  #DISPLAY('    ')
  #DISPLAY('    .')
  #PROMPT(' :',OPTFIELD),%WorkFontName,REQ,DEFAULT('''Arial Cyr'''),WHENACCEPTED(%NormalizeName(%WorkFontName))
  #PROMPT('  CHARSET:CYRILLIC',CHECK),%FontCharset,AT(10),DEFAULT(%True)
  #PROMPT('  ',CHECK),%AllControlsUse,AT(10),DEFAULT(%True)
  #ENABLE(~%AllControlsUse),CLEAR
    #PROMPT('',FROM(%ReportControl,(%ReportControlType<>'IMAGE') AND (%ReportControlType<>'LINE') AND (%ReportControlType<>'BOX') AND (%ReportControlType<>'ELLIPSE'))),%ChangeControls,SELECTION('  ')
  #ENDENABLE
#ENDBOXED
#!
#AT(%AfterOpeningReport),FIRST
#INSERT(%SetFont)
#ENDAT
#!
#AT(%GenerateAllReport),FIRST          #!    MemRpt
#INSERT(%SetFont)
#ENDAT
#!
#GROUP(%SetFont)
SETTARGET(%Report)
#IF(%AllControlsUse)
#INSERT(%ScanAllControls,%WorkFontName,%FontCharset)
#ELSE
  #FOR(%ReportControl),WHERE(INLIST(%ReportControl,%ChangeControls))
    #IF((%ReportControlType<>'IMAGE') AND (%ReportControlType<>'LINE') AND (%ReportControlType<>'BOX') AND (%ReportControlType<>'ELLIPSE'))
%ReportControl{PROP:FontName} = %WorkFontName
      #IF(%FontCharset)
%ReportControl{PROP:FontCharSet} = CHARSET:CYRILLIC
      #ENDIF
    #ENDIF
  #ENDFOR
#ENDIF
SETTARGET()
#!------------------------------------------------------------------------------
#!------------------------------------------------------------------------------
#CODE(SetReportControlFontCode,'     '),DESCRIPTION('    "' & %ReportLabel & '"')
#!------------------------------------------------------------------------------
#BOXED('')
  #DISPLAY('   ')
  #DISPLAY('    .')
  #PROMPT(' REPORT`:',@s255),%ReportLabel,REQ,DEFAULT('REPORT')
  #PROMPT(' :',OPTFIELD),%WorkFontName,REQ,DEFAULT('''Arial Cyr'''),WHENACCEPTED(%NormalizeName(%WorkFontName))
  #PROMPT('  CHARSET:CYRILLIC',CHECK),%FontCharset,AT(10),DEFAULT(%True)
#ENDBOXED
#!
SETTARGET(%ReportLabel)
#INSERT(%ScanAllControls,%WorkFontName,%FontCharset)
SETTARGET()
#!------------------------------------------------------------------------------
#!------------------------------------------------------------------------------
#!    SetReportControlFont  SetReportControlFontCode
#!------------------------------------------------------------------------------
#GROUP(%ScanAllControls,%FontName,%SetCharset)
LOOP F# = 0 TO LASTFIELD()
  IF ~INLIST(F#{PROP:Type},CREATE:Image,CREATE:Line,CREATE:Box,CREATE:Ellipse)
     F#{PROP:FontName} = %FontName
  #IF(%SetCharset)
     F#{PROP:FontCharSet} = CHARSET:CYRILLIC
  #ENDIF
  END
END
#!------------------------------------------------------------------------------
#!       "!"
#!------------------------------------------------------------------------------
#GROUP(%NormalizeName,*%Name)
  #IF(SUB(%Name,1,1)='!')
    #SET(%Name,SUB(%Name,2,LEN(%Name)-1))
  #ENDIF
#!------------------------------------------------------------------------------
#!------------------------------------------------------------------------------
